;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname cc1-gr4) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write repeating-decimal #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; cc1-gr4.rkt

;;; Q1

(define (foo n) 
  (if (= n 0)
      1
      (foo (- n 2))))    ; oups... on n'est pas certain de tomber sur n=0

; La fonction foo est definie sur les entiers pairs. Elle retourne toujours 1.
(check-expect (foo (* 2 (random 100))) 1)
; (foo 5) --> part en boucle infinie !

;;; Q2

(define (pi-carre n)
  (local [(define (somme-jusqua n)   ; calcul de la somme des 1/(k*k) pour k=1..n
            (if (= n 0)
                0
                (+ (somme-jusqua (- n 1)) (/ 1 (sqr n)))))]
    (* 6 (somme-jusqua n))))

(show (sqrt (pi-carre 1000)))    ; convergence assez lente...

;;; Q3

(define (colonne n)
  (if (= n 0)
      empty-image
      (above (colonne (- n 1))
             (circle 20 'solid' "yellow"))))

(show (colonne 3))

;;; Q4

(define (pyramide n)
  (if (= n 0)
      empty-image
      (beside (colonne n)
              (pyramide (- n 1)))))

(show (pyramide 3))

;;; Q5 - Animation

; a) Le monde est l'angle polaire theta de la planete rouge (angle par-rapport a Ox).
(define INIT 0)    ; pole Est de l'ellipse

; b) Si theta est dans [0,pi] la planete est devant, sinon elle est derriere (important
; pour le underlay). Ah, ca va m'obliger a faire en sorte que theta soit toujours
; dans [0,2pi] car modulo ne fonctionnera pas ! Ok, vu.

(define (suivant theta)
  (if (< theta (* 2 pi))
      (+ theta #i0.03)
      0))

; NB : Certains etudiants ont plutot regarde le signe de s = sin(theta) pour savoir
; si la planete etait devant ou derriere. Bien vu, et l'avantage est que la
; fonction suivant n'a plus besoin de if...

; c) Je suis tres content, merci, on me donne toutes les equations des ellipses :-)

(define FOND (rectangle 400 400 'solid "black"))
(define ETOILE (circle 100 'solid "yellow"))
(define PLANETE (circle 20 'solid "red"))

(define (dessiner theta)
  (if (< theta pi)
      (place-image PLANETE
                   (+ 200 (* 150 (cos theta))) (+ 190 (* 80 (sin theta)))
                   (underlay FOND ETOILE))
      (underlay (place-image  PLANETE
                              (+ 200 (* 150 (cos theta))) (+ 190 (* 80 (sin theta)))
                             FOND)
                ETOILE)))

; d)

(big-bang INIT
          (on-tick suivant)     ; l'enonce demande 1/15, un peu lent ?
          (on-draw dessiner))

; Easy ? Easy. Enfin, modulo l'entrainement personnel...
