;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname cc1-gr1) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write repeating-decimal #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; cc1-gr1.rkt

; Q1

(define (foo m n) 
    (if (= m n) 
        1  
        (foo (- m 1) (+ n 1))))   ; oh, des vases communicants !

(check-expect (foo 6 4) 1)
; (foo 6 5) --> ERROR, part en live !

; Q2

(define (s n) 
  (if (= n 1) 
      0                 ; car (= (log 1) 0) 
      (+ (s (- n 1)) (/ (log n) (expt 2 n)))))

(show (s 1000))    ; la limite semble etre 0.507...

; Q3

(define (poupees-russes_v1 n w h k)
  (if (= n 0)
      empty-image
      (underlay (rectangle w h 'outline "red")
                (poupees-russes_v1 (- n 1) (* w k) (* h k) k))))

(show (poupees-russes_v1 5 50 30 1.2))

(define (poupees-russes_v2 n w h k)     ; autre solution...
  (if (= n 1)
      (rectangle w h 'outline "red")
      (local [(define img (poupees-russes_v2 (- n 1) w h k))]
        (underlay img (rectangle (* (image-width img) k) (* (image-height img) k) 'outline "red")))))

(show (poupees-russes_v2 5 50 30 1.2))

; Q4a)

(define-struct monde (img n))   ; img = image en construction, n = nombre de 7 deja tires

(define INIT (make-monde (rectangle 300 300 'solid "yellow") 0))

; Q4b)

(define (suivant m)    ; monde --> monde
  (local [(match-define (monde img n) m)
          (define chiffre (random 10))
          (define ns (if (= chiffre 7) (+ n 1) n))
          (define imgs (place-image (text (number->string chiffre)
                                          (+ 30 (random 21))
                                          (if (= chiffre 7) "red" "blue"))
                                    (+ 10 (random 281))  (+ 10 (random 281))
                                    img))]
    (make-monde imgs ns)))

(define (dessiner m)   ; monde --> scene
  (monde-img m))

(define (final? m)     ; monde --> boolean
  (>= (monde-n m) 5))

(big-bang INIT
          (on-tick suivant 1/4)    ; 4 images/sec
          (on-draw dessiner)
          (stop-when final?))


